#!javascript
/*
	Send URL and document title to dwbc on every navigation via management socket.
*/

function socketWrite(str)
{
	var sock = system.getEnv('DWBMGMT_SOCK');
	system.socketWrite(str + "\n", sock);
}

function update_addressbar(url)
{
	socketWrite("address " + url);
}

function getTitle()
{
	return document.title;
}

function update_title(wv, url)
{
	var title = JSON.parse(wv.inject(util.getBody(getTitle), false));
	title = title.replace(/[\r\n]/g, '');
	if(title == '') title = url || wv.uri;
	socketWrite("title " + title);
}

function getRelLinks()
{
	var rellinks = [];
	var links = document.getElementsByTagName('link');
	for(var n = 0; n < links.length; n++)
	{
		var lnk = links[n];
		var href = lnk.href;
		rellinks.push({'rel': lnk.getAttribute('rel'), 'url': href, 'type': lnk.getAttribute('type'), 'title': lnk.getAttribute('title')});
	}
	return rellinks;
}

function reset_rellinks()
{
	socketWrite("link reset");
}

function update_rellinks(wv)
{
	var rellinks = JSON.parse(wv.inject(util.getBody(getRelLinks), false));
	for(var n = 0; n < rellinks.length; n++)
	{
		var lnk = rellinks[n];
		lnk.rel = lnk.rel.replace(/ /g, '_');
		if(lnk.rel == 'previous') lnk.rel = 'prev';
		if(lnk.rel == 'toc') lnk.rel = 'contents';
		lnk.url = lnk.url.replace(/ /g, '%20');
		lnk.type = lnk.type.replace(/ /g, '_');
		socketWrite("link " + lnk.rel + " " + lnk.url + " " + lnk.type + " " + lnk.title);
	}
}



/***************************************/
/*************** Signals ***************/
/***************************************/


signals.connect('createTab', function(webview)
{
	reset_rellinks();
});

signals.connect('tabFocus', function(webview, json)
{
	update_addressbar(webview.uri);
	update_title(webview, webview.uri);
	reset_rellinks();
	update_rellinks(webview);
});

signals.connect('loadCommitted', function(webview)
{
	update_addressbar(tabs.current.uri);
});

signals.connect('resource', function(webview, frame, request, response)
{
	1;
});

signals.connect('loadFinished', function(webview)
{
	update_title(tabs.current);
	reset_rellinks();
	update_rellinks(tabs.current);
});

signals.connect('documentLoaded', function(webview, frame)
{
	1;
});

signals.connect('closeTab', function(webview)
{
	update_addressbar(tabs.current.uri);
	update_title(tabs.current);
	reset_rellinks();
	update_rellinks(tabs.current);
});
