#!javascript

function del_div()
{
	function save(node, type, name)
	{
		var val;
		if(type == 'attr' && node.getAttribute) val = node.getAttribute(name);
		else if(type == 'style' && node.style) val = node.style[name];
		if(val == undefined || val == null) val = '';
		node.setAttribute('save-'+type+'-'+name, val);
	}
	
	function restore(node, type, name)
	{
		if(node.getAttribute)
		{
			var val = node.getAttribute('save-'+type+'-'+name);
			if(val != undefined && val != null)
			{
				if(type == 'attr') node.setAttribute(name, val);
				else if(type == 'style') node.style[name] = val;
			}
		}
	}
	
	function del_div_hilight(evt)
	{
		if(evt) evt.stopPropagation();
		var path0 = getCssPath(this, false, false);
		var path1 = getCssPath(this, true, false);
		var path2 = getCssPath(this, true, true);
		var path = path0;
		if(path0 != path1) path += "\n" + path1;
		if(path1 != path2) path += "\n" + path2;
		document.body.setAttribute('title', path+"\n"+"Click to remove, Esc to cancel.");
		console.log(path);
		
		var parent = this.parentNode;
		while(parent)
		{
			del_div_lolight.call(parent, undefined);
			parent = parent.parentNode;
		}
		for(style in styles)
		{
			save(this, 'style', style);
			this.style[style] = styles[style];
		}
		return true;
	}
	
	function del_div_lolight(evt)
	{
		if(evt) evt.stopPropagation();
		for(style in styles)
		{
			restore(this, 'style', style);
		}
		return true;
	}
	
	function del_div_remove(evt)
	{
		if(evt)
		{
			evt.stopPropagation();
			evt.stopImmediatePropagation();
		}
		this.parentNode.removeChild(this);
		del_div_init('remove');
		return true;
	}
	
	function del_div_cancel(evt)
	{
		if(evt.keyCode == 27) del_div_init('remove');
	}
	
	function del_div_init(add_remove)
	{
		if(add_remove == 'add')
			save(document.body, 'attr', 'title');
		else
			restore(document.body, 'attr', 'title');
		
		for(var tag in tags)
		{
			var elems = document.getElementsByTagName(tag);
			for(var idx = 0; idx < elems.length; idx++)
			{
				elems[idx][add_remove+'EventListener']('mouseover', del_div_hilight);
				elems[idx][add_remove+'EventListener']('mouseout', del_div_lolight);
				elems[idx][add_remove+'EventListener']('click', del_div_remove);
				document[add_remove+'EventListener']('keydown', del_div_cancel);
				if(add_remove == 'remove')
				{
					del_div_lolight.call(elems[idx], undefined);
				}
			}
		}
	}
	
	var styles = {
		'border': "dashed 2px red",
		'background-color': "pink",
		'cursor': "crosshair",
	};
	var tags = {'DIV': 1, 'P': 1, 'TABLE': 1, 'TD': 1};
	
	del_div_init('add');
}

function del_div_inject()
{
	var cssPath = include(system.getEnv('HOME')+'/.config/dwb/userscripts/include/cssPath.js');
	tabs.current.inject("getCssPath=" + cssPath.getPath.prototype.constructor, true);
	tabs.current.inject(util.getBody(del_div), true);
}

bind('dd', del_div_inject, 'del_div');
