#!javascript

function drawception_improvement()
{
	var btnBackg = $('<input type="button" id="setBgColor" value="New"/>');
	var btnFlood = $('<input type="button" id="floodFill" value="Flood"/>');
	var ovlFlood = $('<div id="floodFillBox" class="canvasOverlay" style="cursor: context-menu;"></div>');
	var btnFlat = $('<input type="button" id="Flatten" value="Flat"/>');
	var divFlat = $('<div id="flattenBox"><input type="button" id="flatRGB" value="RGB"/><input type="button" id="flatHCL" value="HCL"/></div>');
	var btnLoad = $('<input type="button" id="loadImage" value="Load"/>');
	var btnFile = $('<input type="file" id="loadFile" value="Load"/>');
	var divFile = $('<div>'+
		'<table border=1>'+
			'<tr>'+
				'<td><input type="radio" name="position" value="NW" checked="checked"/></td>'+
				'<td><input type="radio" name="position" value="NC"/></td>'+
				'<td><input type="radio" name="position" value="NE"/></td>'+
			'</tr>'+
			'<tr>'+
				'<td><input type="radio" name="position" value="MW"/></td>'+
				'<td><input type="radio" name="position" value="MC"/></td>'+
				'<td><input type="radio" name="position" value="ME"/></td>'+
			'</tr>'+
			'<tr>'+
				'<td><input type="radio" name="position" value="SW"/></td>'+
				'<td><input type="radio" name="position" value="SC"/></td>'+
				'<td><input type="radio" name="position" value="SE"/></td>'+
			'</tr>'+
			'<tr><td colspan=3><input type="radio" name="position" value="manual" id="putFilePosManual"/><label for="putFilePosManual">✍</label></td></tr>'+
		'</table>'+
		'<input type="checkbox" name="stretch-horiz" id="putFileStretchHoriz"/><label for="putFileStretchHoriz">&harr;</label> '+
		'<input type="checkbox" name="stretch-verti" id="putFileStretchVerti"/><label for="putFileStretchVerti">&varr;</label> '+
		'<input type="checkbox" name="keep-ratio" id="putFileKeepRatio" checked="checked"/><label for="putFileKeepRatio">&div;</label> '+
		'<input type="button" id="putFile" value="Put"/>'+
		'</div>');
	var rdrFile = new FileReader();
	var imgFile = new Image();
	var ovlFile = $('<div id="putImageBox" class="canvasOverlay">'+
		'<img id="ovlImage" style="position: absolute; z-index: 0; opacity: 0.6;"/>'+
		'</div>');
	var btnDown = $('<input type="button" value="Save"/>');
	var bt1Size = $('<input type="range" min=1 max=50  class="brushSizer" />');
	var bt2Size = $('<input type="range" min=1 max=500 class="brushSizer" />');
	var brushIndicator = $('<div style="position: absolute; z-index: 0; border: dashed 1px black;"></div>');
	
	var wrapper = $('<div></div>');
	wrapper.insertAfter($('#drawingCanvasHolder').next());
	// $('canvas').css('cursor', null);
	
	
	wrapper.append(btnBackg);
	btnBackg.click(function()
	{
		drawApp.context.fillStyle = $('#colorOptions button.selected').data('color');
		drawApp.context.fillRect(0, 0, drawApp.canvas.width(), drawApp.canvas.height());
		save();
	});
	
	wrapper.append(btnDown);
	btnDown.click(function()
	{
		var dataurl = drawApp.context.canvas.toDataURL().replace(/image\/[^;,]+/, 'application/octet-stream');
		//var anchor = $('<a>');
		//anchor.attr('href', dataurl);
		//anchor.attr('download', 'draw.png');
		//$('body').append(anchor);
		//anchor.click();
		//anchor.remove();
		location.href = dataurl;
	});
	
	wrapper.append(btnFlood);
	btnFlood.click(function()
	{
		if(btnFlood.data('pressed'))
		{
			/* Turn off Flood mode. */
			btnFlood.data('pressed', 0);
			btnFlood.css('border', '');
			ovlFlood.hide();
		}
		else
		{
			/* Turn on Flood mode. */
			btnFlood.data('pressed', 1);
			btnFlood.css('border', 'inset');
			ovlFlood.show();
		}
	});
	
	ovlFlood.insertBefore($('#drawingCanvasHolder'));
	ovlFile.insertBefore($('#drawingCanvasHolder'));
	$('.canvasOverlay')
		.css({'position': 'absolute', 'z-index': 1, 'width': $('#drawingCanvas').width() + 'px', 'height': $('#drawingCanvas').height() + 'px'})
		.hide();
	
	ovlFlood.click(function(evt)
	{
		/* User clicked on Flood helper overlaid box. */
		var x = evt.offsetX;
		var y = evt.offsetY;
		var color = $('#colorOptions button.selected').data('color');
		var rgb = color_hex2dec_chan(color);
		floodFill(drawApp.context, x, y, rgb[0], rgb[1], rgb[2]);
		save();
	});
	
	wrapper.append(btnFlat);
	btnFlat.click(function()
	{
		divFlat.toggle();
	});
	wrapper.append(divFlat);
	divFlat.hide();
	divFlat.find('input[type=button]').click(function()
	{
		var colorSpace = this.value;
		var canvasWidth = drawApp.context.canvas.width;
		var canvasHeight = drawApp.context.canvas.height;
		var imageData = drawApp.context.getImageData(0, 0, canvasWidth, canvasHeight);
		var validColors = $('#colorOptions button').map(function(){ return [color_hex2dec_chan($(this).data('color'))]; });
		var changedPixels = 0;
		if(colorSpace == 'HCL')
			for(var i = 0; i < validColors.length; i++)
				validColors[i] = rgb2hcl(validColors[i][0], validColors[i][1], validColors[i][2]);
		
		for(var xy = 0; xy < canvasWidth*canvasHeight*4; xy += 4)
		{
			var valid = false;
			var minDistance = -1;
			for(var i = 0; i < validColors.length; i++)
			{
				var dist;
				switch(colorSpace)
				{
					case 'HCL':
						var hcl1 = rgb2hcl(imageData.data[xy], imageData.data[xy+1], imageData.data[xy+2]);
						dist = colorDistance(hcl1, validColors[i]);
						break;
					default:
						dist = colorDistance([imageData.data[xy], imageData.data[xy+1], imageData.data[xy+2]], validColors[i]);
				}
				if(dist == 0)
				{
					valid = true;
					break;
				}
				else if(minDistance == -1 || dist < minDistance)
				{
					minDistance = dist;
					nearsetColor = validColors[i];
				}
			}
			if(!valid)
			{
				imageData.data[xy] = nearsetColor[0];
				imageData.data[xy+1] = nearsetColor[1];
				imageData.data[xy+2] = nearsetColor[2];
				changedPixels++;
			}
		}
		if(changedPixels > 0)
		{
			drawApp.context.constructor.prototype.putImageData.call(drawApp.context, imageData, 0, 0);
			save();
		}
		divFlat.hide();
	});
	
	// wrapper.append(btnLoad);
	btnLoad.click(function()
	{
		var url = prompt("Enter an image URL", "file://");
		if(url == null) return;
		var img = new Image();
		img.onload = function()
		{
			drawApp.context.drawImage(img, 0, 0, drawApp.context.canvas.width, drawApp.context.canvas.height);
			save();
		}
		//img.crossOrigin = 'Anonymous';
		img.src = url;
	});
	wrapper.append(btnFile);
	btnFile.change(function(evt)
	{
		divFile.find('input').attr('disabled', 'disabled');
		divFile.show();
		imgFile.src = '';
		$('#ovlImage').attr('src', null);
		ovlFile.show();
		ovlFile.data('phase', 'none');
		ovlFile.css('cursor', '');
		rdrFile.readAsDataURL(evt.target.files[0]);
	});
	wrapper.append(divFile);
	divFile.hide();
	divFile.find('input').change(function()
	{
		var cnvw = drawApp.context.canvas.width;
		var cnvh = drawApp.context.canvas.height;
		var X = 0;
		var Y = 0;
		var W = imgFile.width;
		var H = imgFile.height;
		var pos = divFile.find('input[name=position]:checked').val();
		var grav;
		var hStretch = divFile.find('input[name=stretch-horiz]').is(':checked');
		var vStretch = divFile.find('input[name=stretch-verti]').is(':checked');
		// apprise("Keep aspect ratio?", {'confirm': true, 'textOk': 'Keep', 'textCancel': 'Stretch'}, function(keepRatio){});
		if(hStretch && vStretch) divFile.find('input[name=keep-ratio]').prop('checked', false);
		var keepRatio = divFile.find('input[name=keep-ratio]').is(':checked');
		
		if(grav = pos.match(/^([NMS])([WCE])$/))
		{
			if(imgFile.width > cnvw || imgFile.height > cnvh)
			{
				var scale = Math.min(cnvw/imgFile.width, cnvh/imgFile.height);
				W = scale * imgFile.width;
				H = scale * imgFile.height;
			}
			if(hStretch) W = cnvw;
			if(vStretch) H = cnvh;
			if(keepRatio)
			{
				if(!hStretch) W = H * imgFile.width / imgFile.height;
				if(!vStretch) H = W * imgFile.height / imgFile.width;
			}
			switch(grav[2])
			{
				case 'C': X = (cnvw - W) / 2; break;
				case 'E': X = cnvw - W; break;
			}
			switch(grav[1])
			{
				case 'M': Y = (cnvh - H) / 2; break;
				case 'S': Y = cnvh - H; break;
			}
			ovlFile.css('cursor', '');
		}
		else
		{
			ovlFile.css('cursor', 'nw-resize');
			ovlFile.data('phase', 'topleft');
		}
		$('#ovlImage').css({'left': X, 'top': Y, 'width': W, 'height': H});
		ovlFile.data('coords', {'X': X, 'Y': Y, 'W': W, 'H': H});
	});
	ovlFile.click(function(evt)
	{
		var evtc = eventCoordinates(evt, this);
		var phase = $(this).data('phase');
		var coord = ovlFile.data('coords');
		switch(phase)
		{
			case 'topleft':
				if(divFile.find('input[name=stretch-horiz]').is(':checked'))
					evtc.x = 0;
				if(divFile.find('input[name=stretch-verti]').is(':checked'))
					evtc.y = 0;
				$('#ovlImage').css({'left': evtc.x, 'top': evtc.y});
				coord.X = evtc.x;
				coord.Y = evtc.y;
				ovlFile.data('coords', coord);
				
				$(this).data('phase', 'bottomright');
				ovlFile.css('cursor', 'se-resize');
			break;
			case 'bottomright':
				ovlImageBottomRight(evtc);
				
				$(this).data('phase', 'topleft');
				ovlFile.css('cursor', 'nw-resize');
			break;
		}
	});
	ovlFile.mousemove(function(evt)
	{
		var evtc = eventCoordinates(evt, this);
		var phase = $(this).data('phase');
		if(phase == 'bottomright') ovlImageBottomRight(evtc);
	});
	function ovlImageBottomRight(evtc)
	{
		var keepRatio = divFile.find('input[name=keep-ratio]').is(':checked');
		var coord = ovlFile.data('coords');
		var W; 
		var H;
		if(divFile.find('input[name=stretch-horiz]').is(':checked'))
			W = drawApp.context.canvas.width;
		else
			W = evtc.x - coord.X;
		if(divFile.find('input[name=stretch-verti]').is(':checked'))
			H = drawApp.context.canvas.height;
		else
			if(keepRatio) H = W * imgFile.height / imgFile.width;
			else H = evtc.y - coord.Y;
		$('#ovlImage').css({'width': W, 'height': H});
		coord.W = W;
		coord.H = H;
		ovlFile.data('coords', coord);
	}
	$('#putFile').click(function()
	{
		var coord = ovlFile.data('coords');
		drawApp.context.drawImage(imgFile, coord.X, coord.Y, coord.W, coord.H);
		save();
		ovlFile.data('coords', {});
		divFile.hide();
		ovlFile.hide();
		btnFile.val(null);
	});
	rdrFile.onload = function(evt)
	{
		imgFile.src = evt.target.result;
	};
	imgFile.onload = function()
	{
		$('#ovlImage').attr('src', imgFile.src);
		divFile.find('input').attr('disabled', null);
		$(divFile.find('input')[0]).change();
	};
	
	
	wrapper.append(bt1Size);
	wrapper.append(bt2Size);
	wrapper.append(brushIndicator);
	drawApp.setSizeOriginal = drawApp.setSize;
	drawApp.setSize = function(size)
	{
		$('.brushSizer').val(size);
		brushIndicatorSize(size);
		drawApp.setSizeOriginal(size);
	};
	$('.brushSizer').change(function()
	{
		var size = $(this).val();
		$('.brushSizer').not($(this)).val(size);
		brushIndicatorSize(size);
		drawApp.setSizeOriginal(size);
	});
	function brushIndicatorSize(size)
	{
		brushIndicator.text(size);
		var radius = parseInt(size/2) + 'px';
		brushIndicator.css({'border-radius': radius, '-webkit-border-radius': radius, 'width': size, 'height': size});
	}
	
	
	
	function eventCoordinates(evt, node)
	{
		var X = evt.pageX - $(node).offset().left;
		var Y = evt.pageY - $(node).offset().top;
		return {'x': X, 'y': Y};
	}
	
	function colorDistance(a, b)
	{
		return Math.sqrt(Math.pow(a[0] - b[0], 2) + Math.pow(a[1] - b[1], 2) + Math.pow(a[2] - b[2], 2));
	}
	
	function rgb2hcl(r, g, b)
	{
	    r /= 255, g /= 255, b /= 255;
	    var max = Math.max(r, g, b), min = Math.min(r, g, b);
	    var h, c;
	    var l = (max + min) / 2;
		
		if(max == min)
			h = c = 0;
		else
		{
			var d = max - min;
			c = l > 0.5 ? d / (2 - max - min) : d / (max + min);
			switch(max)
			{
				case r: h = (g - b) / d + (g < b ? 6 : 0); break;
				case g: h = (b - r) / d + 2; break;
				case b: h = (r - g) / d + 4; break;
        	}
			h /= 6;
		}
		return [h, c, l];
	}
	
	function color_hex2dec_chan(str)
	{
		var hex, r, g, b, a;
		if(hex = str.match(/^#?(.)(.)(.)(.)?$/))
		{
			hex[1] = '' + hex[1] + hex[1];
			hex[2] = '' + hex[2] + hex[2];
			hex[3] = '' + hex[3] + hex[3];
			if(hex[4] == undefined) hex[4] = 'F';
			hex[4] = '' + hex[4] + hex[4];
		}
		else if(hex = str.match(/^#?(..)(..)(..)(..)?$/))
		{
			if(hex[4] == undefined) hex[4] = 'FF';
		}
		else
		{
			console.log("Bad hex color code: "+str);
			return undefined;
		}
		r = parseInt(hex[1], 16);
		g = parseInt(hex[2], 16);
		b = parseInt(hex[3], 16);
		a = parseInt(hex[4], 16);
		return [r, g, b, a];
	}
	
	function floodFill(context, X, Y, fillColorR, fillColorG, fillColorB)
	{
		var canvasWidth = context.canvas.width;
		var canvasHeight = context.canvas.height;
		var colorLayer = context.getImageData(0, 0, canvasWidth, canvasHeight);
		var pixelStack = [[X, Y]];
		var drawingAreaX = 0;
		var drawingAreaY = 0;
		var drawingAreaWidth = canvasWidth;
		var drawingAreaHeight = canvasHeight;
		var drawingBoundLeft = drawingAreaX;
		var drawingBoundTop = drawingAreaY;
		var drawingBoundRight = drawingAreaX + drawingAreaWidth - 1;
		var drawingBoundBottom = drawingAreaY + drawingAreaHeight - 1;
		var startPixelPos = (Y * canvasWidth + X) * 4;
		var startR = colorLayer.data[startPixelPos];
		var startG = colorLayer.data[startPixelPos+1];
		var startB = colorLayer.data[startPixelPos+2];
		
		function matchStartColor(pixelPos)
		{
		  var r = colorLayer.data[pixelPos];	
		  var g = colorLayer.data[pixelPos+1];	
		  var b = colorLayer.data[pixelPos+2];
		
		  return (r == startR && g == startG && b == startB);
		}
		
		function colorPixel(pixelPos)
		{
		  colorLayer.data[pixelPos] = fillColorR;
		  colorLayer.data[pixelPos+1] = fillColorG;
		  colorLayer.data[pixelPos+2] = fillColorB;
		  colorLayer.data[pixelPos+3] = 255;
		}
		
		var n0 = 0;
		while(pixelStack.length && n0 < drawingAreaWidth*drawingAreaHeight)
		{
		  n0++;
		  var newPos, x, y, pixelPos, reachLeft, reachRight, n1;
		  newPos = pixelStack.pop();
		  x = newPos[0];
		  y = newPos[1];
		  
		  pixelPos = (y*canvasWidth + x) * 4;
		  n1 = 0;
		  while(y-- >= drawingBoundTop && matchStartColor(pixelPos) && n1 < drawingAreaWidth*drawingAreaHeight)
		  {
		  	n1++;
		    pixelPos -= canvasWidth * 4;
		  }
		  pixelPos += canvasWidth * 4;
		  ++y;
		  reachLeft = false;
		  reachRight = false;
		  n1 = 0;
		  while(y++ < canvasHeight-1 && matchStartColor(pixelPos) && n1 < drawingAreaWidth*drawingAreaHeight)
		  {
		    n1++;
		    colorPixel(pixelPos);
			
		    if(x > 0)
		    {
		      if(matchStartColor(pixelPos - 4))
		      {
		        if(!reachLeft){
		          pixelStack.push([x - 1, y]);
		          reachLeft = true;
		        }
		      }
		      else if(reachLeft)
		      {
		        reachLeft = false;
		      }
		    }
			
		    if(x < canvasWidth-1)
		    {
		      if(matchStartColor(pixelPos + 4))
		      {
		        if(!reachRight)
		        {
		          pixelStack.push([x + 1, y]);
		          reachRight = true;
		        }
		      }
		      else if(reachRight)
		      {
		        reachRight = false;
		      }
		    }
					
		    pixelPos += canvasWidth * 4;
		  }
		}
		
		// context.putImageData(colorLayer, 0, 0);
		drawApp.context.constructor.prototype.putImageData.call(drawApp.context, colorLayer, 0, 0);
	}
}

signals.connect('loadFinished', function(webview, frame)
{
	if(webview.allFrames.length > 0)
	{
		if(webview.uri.match(/^https?:\/\/([^\/]+\.)?drawception\.com\//))
		{
			webview.inject(util.getBody(drawception_improvement), true);
		}
	}
});
