#!javascript

function yt_hover_preview()
{
	function ythpv_close()
	{
		var e = document.getElementById('ythpv');
		if(e) e.parentNode.removeChild(e);
	}

	function ythpv(event)
	{
		if(document.getElementById('ythpv')) return false;
		var atag = event.target;
		var box = document.createElement('DIV');
		var rect = atag.getClientRects();
		rect = rect[0];

		box.id = "ythpv";
		box.style.position = "fixed";
		box.style.top = rect.top + rect.height + 4 + "px";
		box.style.left = rect.left + 0 + "px";
		box.style.padding = "4pt";
		box.style.paddingTop = 0;
		box.style.border = "1px solid black";
		box.style.backgroundColor = "white";

		var ytid = get_ytId(atag);
		if(!ytid) return false;
		var html_imgs;
		for (var n = 0; n <= 3; n++)
		{
			var src = get_ytPreviewImg(ytid, n);
			html_imgs = (html_imgs ? html_imgs : '') + "<img src='" + src + "' />";
		}
		box.innerHTML = "<h3 id='ythpv-title'>...</h3><div><i id='ythpv-user'>...</i></div>" + html_imgs;
		document.body.appendChild(box);
		
		get_ytData(ytid, function(data)
		{
			if(document.getElementById('ythpv'))
			{
				document.getElementById('ythpv-title').innerHTML = data.title;
				document.getElementById('ythpv-user').innerHTML = data.author_name;
			}
		});
		return true;
	}

	function get_ytId(atag)
	{
		var url = atag.href;
		if(!url) return null;
		var g = url.match(/:\/\/(?:youtu\.be\/|[^:\/]*youtube.com\/watch\?v=)([a-zA-Z0-9_-]{11})/);
		if(!g) return null;
		return g[1];
	}

	function get_ytData(id, cb)
	{
		var xhr = new XMLHttpRequest();
		var watch_url = "http://www.youtube.com/watch?v=" + id;
		//var url = "http://youtube.com/get_video_info?video_id=" + id;
		//var url = "http://www.youtube.com/oembed?url=http://www.youtube.com/watch?v=" + id + "&format=json";
		var url = "https://noembed.com/embed?url=" + encodeURIComponent(watch_url);
		xhr.open("GET", url);
		xhr.onreadystatechange = function()
		{
			var title = null;
			var data = {};
			if (xhr.readyState == 4 && xhr.status == 200)
			{
				//title = getQueryVariable(xhr.responseText, "title");
				data = JSON.parse(xhr.responseText);
			}
			cb(data);
		}
		xhr.send();
	}

	function get_ytPreviewImg(id, n)
	{
		if(!n) n = "default";
		return "http://i.ytimg.com/vi/" + id + "/" + n + ".jpg";
	}

	function getQueryVariable(qs, name)
	{
		var vars = qs.split('&');
		for (var i = 0; i < vars.length; i++)
		{
			var pair = vars[i].split('=');
			if (decodeURIComponent(pair[0]) == name)
			{
				return decodeURIComponent(pair[1]);
			}
		}
		return null;
	}


	links = document.getElementsByTagName('A');

	for (var n = 0; n < links.length; n++)
	{
		if(get_ytId(links[n]) != null)
		{
			links[n].addEventListener("mouseover", ythpv);
			links[n].addEventListener("mouseout", ythpv_close);
		}
	}
}



signals.connect('documentLoaded', function(webview, frame)
{
	if(webview.allFrames.length > 0)
	{
		webview.inject(util.getBody(yt_hover_preview), true);
	}
});
